
type ident = string
    
type exp =
    Varref of ident
  | Vardef of ident*exp
  | Call of exp*(exp list)*(exp option)
  | IntLit of int
  | SGet of exp*ident
  | SSet of exp*ident*exp
  | Assign of ident*exp
  | MakeFun of (ident list)*(ident option)*(exp list)
  | IfStmt of exp*(exp list)*(exp list)
  | And of exp*exp
  | Or of exp*exp
  | Not of exp
  | MakeList of (exp list)
  | Class of ident*(exp option)*(exp list)
  | Return of exp
  | String of string
type operator =
  | O_VRef of ident
  | O_VDef of ident
  | O_Call of int*bool
  | O_IntLit of int
  | O_StrLit of string
  | O_SGet of ident
  | O_SSet of ident
  | O_Assign of ident
  | O_MkFun of (ident list)*(ident option)*(operator list)
  | O_Goto of int
  | O_Branch of int*int
  | O_Pop
  | O_Dup
  | O_Stop
  | O_Nop
  | O_Push of tobject
  | O_ExCall of int*bool

and tobject =
  | IntObj of int
  | FunObj of context*(ident list)*(ident option)*(operator list)
  | BoundFunObj of int*bool*(tobject list)*tobject
  | NormObj of ((string, tobject) Hashtbl.t)
  | NilObj
  | TrueObj
  | FalseObj
  | NativeFunObj of int*bool*((tobject list) -> tobject)
  | ContObj of continuation
  | CallCCObj
  | ListObj of (tobject list)
  | StringObj of string
  | Undef
and context = 
  | ToplevelContext
  | Context of context*((string, tobject) Hashtbl.t)
and continuation = context*(tobject list)*(operator list)
    
    

    
