exception RuntimeError of string
exception Bug of string
  
let raise_error msg =
  raise (RuntimeError msg)
let bug_alert msg = 
  raise (Bug msg)

let rec seq n =
  if n < 0 then
    bug_alert "seq minus"
  else if n = 0 then
    []
  else
    (seq (n-1)) @ [n] 

let rec take n lst =
  match (n,lst) with
    | (0,_) -> []
    | (n,x::xs) -> x::(take (n-1) xs)
    | _ -> raise_error "take fail"
        
let rec remove n lst =
  match (n,lst) with
    | (0,_) -> lst
    | (n,[]) -> raise_error "remove fail"
    | (n,x::xs) -> remove (n-1) xs
        
let part_tail lst =
  let r = List.rev lst in
    (List.rev (List.tl r), List.hd r)
